// pages/feedback/index.js
import http from '../../utils/http'
import util from '../../utils/util'
import api from '../../utils/api'
import baseUrl from "../../utils/env"

Page({

  /**
   * 页面的初始数据
   */
  data: {
    files: [],
    content: '',
    contact: '',
    imgs: []
  },


  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  afterRead: function (e) {
    const { file } = e.detail;
    var files = this.data.files
    if (files.length >= 4) {
      util.error('最多上传4张图片')
      return false
    }
    if (Array.isArray(file)) {
      if (file.length < 4) {
        files = files.concat(file)
      } else {
        files = file
      }
    } else {
      file.path = ''
      files.push(file)
    }
    this.setData({
      files
    })
  },

  delete: function (e) {
    var files = this.data.files
    var index = e.detail.index
    files.splice(index, 1)
    this.setData({ files })
  },

  updateInput(e) {
    getApp().updateInput(this, e)
  },

  save: function () {
    if (!this.data.content) {
      util.error('反馈意见必填')
      return false
    }
    if (!this.data.contact) {
      util.error('联系方式必填')
      return false
    }
    var files = this.data.files
    var that = this
    if (files.length != this.data.imgs.length) {
      for (var i = 0; i < files.length; ++i) {
        util.uploadFile(files[i].url, function (res) {
          var imgs = that.data.imgs
          imgs.push(res.data.path)
          that.setData({ imgs })
          console.log(imgs)
          that.updateInfo()
        })
      }
      // files.forEach(item => {
      //   wx.uploadFile({
      //     filePath: item.url,
      //     name: 'file',
      //     url: baseUrl + 'uploadFile',
      //     success: (res) => {
      //       var data = JSON.parse(res.data)
      //       if (data.code == 0) {
      //         var imgs = that.data.imgs
      //         imgs.push(res.data.path)
      //         that.setData({ imgs })
      //         console.log(imgs)
      //         // that.updateInfo()
      //       } else {
      //         util.error('上传文件失败')
      //       }
      //     }
      //   })
      // })
    } else {
      that.updateInfo()
    }
  },

  updateInfo: function () {
    var files = this.data.files
    var imgs = this.data.imgs
    if (imgs.length != files.length) return false;
    http({
      url: 'feedback/create',
      data: {
        content: this.data.content,
        contact: this.data.contact,
        imgs: imgs.join(',')
      },
      success: function (res) {
        if (res.code == 0) {
          util.success('操作成功')
          setTimeout(()=>{
            wx.navigateBack({
              delta: 1,
            })
          },1000)
        } else {
          util.error('操作失败')
        }
      }
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})